package co.ffive.videoplugin;

import co.ffive.videogen.VideoParams;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** VideoPlugin */
public class VideoPlugin implements MethodCallHandler {
  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "video_plugin");
    channel.setMethodCallHandler(new VideoPlugin());
  }

  static {
    System.loadLibrary("native-lib");
  }
  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("getPlatformVersion")) {

      VideoParams params;
      params = new VideoParams();
      params.history = "kuzia";

      result.success("Androed " +params.history+ android.os.Build.VERSION.RELEASE);
    } else  if (call.method.equals("makeVideo")) {

      VideoParams params;
      params = new VideoParams();


      params.history = call.argument("history");
      params.palette = call.argument("palette");
      params.original = call.argument("original");
      params.originalWidth = call.argument("width");
      params.originalHeight = call.argument("height");

      historyToVideoJNI(params.original,params.history,params.palette,params.originalWidth,params.originalHeight);

      result.success("Androed " +params.history+ android.os.Build.VERSION.RELEASE);
    } else {
      result.notImplemented();
    }



  }

  public static native double co.ffive.videogen.historyToVideoJNI(int[] argb, String jpath, int[] palette, int width, int originalHeight);



}
